

// APT-generated file.

package org.carrot2.source.yahoo;

//Imported for JavaDoc references mostly.
import org.carrot2.util.attribute.*;

import java.util.*;
import javax.annotation.*;

/**
 * Metadata and attributes of the {@link org.carrot2.source.yahoo.YahooSearchService} component. You can use 
 * this descriptor to obtain metadata, such as human readable name and description, about the component 
 * as a whole as well as about its attributes. Using the {@link #attributeBuilder(Map)}
 * you can obtain a builder for type-safe generation of the attribute maps. Please see the
 * <a href="{@docRoot}/overview-summary.html#setting-attributes">main overview</a> for a complete code example. 
 */
@Generated("Generated from org.carrot2.source.yahoo.YahooSearchService")
public final class YahooSearchServiceDescriptor implements IBindableDescriptor
{
    /**
     * The component class for which this descriptor was generated. 
     */
    public final String bindableClassName = "org.carrot2.source.yahoo.YahooSearchService";

    /**
     * Attribute prefix used by the component.
     */
    public final String prefix = "YahooSearchService";

    /**
     * A one sentence summary of the component. It could be presented as a header of the tool
     * tip of the corresponding UI component.
     */
    public final String title = "A superclass shared between Web and News searching services";
    
    /**
     * A short label for the component. It can be presented as a label of the
     * corresponding UI component.
     */
    public final String label = "";

    /**
     * A longer, possibly multi sentence, description of the component. It could be presented
     * as a body of the tool tip of the corresponding UI component.
     */
    public final String description = "";

    /**
     * Attributes of the component. Note that only statically reachable fields are included.
     * Additional attributes may be available at run time. 
     */
    public final static Attributes attributes; 

    /**
     * Attributes declared directly by the component.
     */
    private final static Set<AttributeInfo> ownAttributes;

    /**
     * Attributes declared by the component or its superclasses.
     */
    private final static Set<AttributeInfo> allAttributes;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary 
     * by attribute key.
     */
    private final static Map<String, AttributeInfo> allAttributesByKey;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary by 
     * attribute's field name.
     */
    private final static Map<String, AttributeInfo> allAttributesByFieldName;

    /**
     * Static initializer for internal collections.
     */
    static
    {
        attributes = new Attributes();

        final Set<AttributeInfo> ownAttrs = new HashSet<AttributeInfo>();
        ownAttrs.add(attributes.appid);
        ownAttrs.add(attributes.type);
        ownAttrs.add(attributes.language);

        final Set<AttributeInfo> allAttrs = new HashSet<AttributeInfo>();
        allAttrs.add(org.carrot2.source.yahoo.YahooSearchServiceDescriptor.attributes.appid);
        allAttrs.add(org.carrot2.source.yahoo.YahooSearchServiceDescriptor.attributes.type);
        allAttrs.add(org.carrot2.source.yahoo.YahooSearchServiceDescriptor.attributes.language);

        allAttributes = Collections.unmodifiableSet(allAttrs);
        ownAttributes = Collections.unmodifiableSet(ownAttrs);
        
        final Map<String, AttributeInfo> allAttrsByKey = new HashMap<String, AttributeInfo>();
        final Map<String, AttributeInfo> allAttrsByFieldName = new HashMap<String, AttributeInfo>();
        for (AttributeInfo ai : allAttrs)
        {
            allAttrsByKey.put(ai.key, ai);
            allAttrsByFieldName.put(ai.fieldName, ai);
        }

        allAttributesByKey = Collections.unmodifiableMap(allAttrsByKey);
        allAttributesByFieldName = Collections.unmodifiableMap(allAttrsByFieldName);
    }

    
    /* Attribute keys. */

    /**
     * Constants for all attribute keys of the {@link org.carrot2.source.yahoo.YahooSearchService} component.
     */
    public static class Keys 
    {
        protected Keys() {} 

        /** Attribute key for: {@link org.carrot2.source.yahoo.YahooSearchService#appid}. */
        public static final String APPID = "YahooSearchService.appid";
        /** Attribute key for: {@link org.carrot2.source.yahoo.YahooSearchService#type}. */
        public static final String TYPE = "YahooSearchService.type";
        /** Attribute key for: {@link org.carrot2.source.yahoo.YahooSearchService#language}. */
        public static final String LANGUAGE = "YahooSearchService.language";
    }


    /* Attribute descriptors. */

    /**
     * All attributes of the {@link org.carrot2.source.yahoo.YahooSearchService} component.
     */
    public static final class Attributes
    {
        private Attributes() { /* No public instances. */ }

        /**
         *          */
        public final AttributeInfo appid = 
            new AttributeInfo(
                "YahooSearchService.appid",
                "org.carrot2.source.yahoo.YahooSearchService",
                "appid",
                "Application ID required for Yahoo! services. Please obtain your own appid for\nproduction deployments.",
                "Application ID",
                "Application ID required for Yahoo! services",
                "Please obtain your own appid for production deployments.",
                "Service",
                org.carrot2.util.attribute.AttributeLevel.ADVANCED,
                null
            );

        /**
         *          */
        public final AttributeInfo type = 
            new AttributeInfo(
                "YahooSearchService.type",
                "org.carrot2.source.yahoo.YahooSearchService",
                "type",
                "Query words interpretation.",
                "Query interpretation",
                "Query words interpretation",
                null,
                "Search query",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );

        /**
         *          */
        public final AttributeInfo language = 
            new AttributeInfo(
                "YahooSearchService.language",
                "org.carrot2.source.yahoo.YahooSearchService",
                "language",
                "The language the results are written in. Value must be one of the supported\nlanguage codes. Omitting language returns results in any language.",
                "Language",
                "The language the results are written in",
                "Value must be one of the supported language codes. Omitting language returns results in any language.",
                "Results filtering",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );


    }

    /**
     * Attribute map builder for the  {@link org.carrot2.source.yahoo.YahooSearchService} component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     */
    public static class AttributeBuilder 
    {
        /** The attribute map populated by this builder. */
        public final Map<String, Object> map;

        /**
         * Creates a builder backed by the provided map.
         */
        protected AttributeBuilder(Map<String, Object> map)
        {
            
            this.map = map;
        }


        
        
        /**
         * Application ID required for Yahoo! services. Please obtain your own appid for
production deployments.
         * 
         * @see org.carrot2.source.yahoo.YahooSearchService#appid 
         */
        public AttributeBuilder appid(java.lang.String value)
        {
            map.put("YahooSearchService.appid", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * Query words interpretation.
         * 
         * @see org.carrot2.source.yahoo.YahooSearchService#type 
         */
        public AttributeBuilder type(org.carrot2.source.yahoo.YahooSearchService.QueryType value)
        {
            map.put("YahooSearchService.type", value);
            return this;
        }
        
        
        
        /**
         * Query words interpretation.
         * 
         * @see org.carrot2.source.yahoo.YahooSearchService#type
         */
        public AttributeBuilder type(Class<? extends org.carrot2.source.yahoo.YahooSearchService.QueryType> clazz)
        {
            map.put("YahooSearchService.type", clazz);
            return this;
        }
        
        
        
        
        
        /**
         * The language the results are written in. Value must be one of the supported
language codes. Omitting language returns results in any language.
         * 
         * @see org.carrot2.source.yahoo.YahooSearchService#language 
         */
        public AttributeBuilder language(java.lang.String value)
        {
            map.put("YahooSearchService.language", value);
            return this;
        }
        
        
        
        
        
    }

    /**
     * Creates an attribute map builder for the component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     * 
     * @param attributeValues An existing map which should be used to collect attribute values. 
     *        Attribute values set by this builder will be added to the provided map, overwriting
     *        previously defined mappings, if any.
     */
    public static AttributeBuilder attributeBuilder(Map<String, Object> attributeValues)
    {
        return new AttributeBuilder(attributeValues);
    }
    
    /* IBindableDescriptor */

    @Override 
    public String getPrefix()
    {
        return prefix;
    }

    @Override 
    public String getTitle()
    {
        return title;
    }
    
    @Override 
    public String getLabel()      
    { 
        return label;
    }
    
    @Override 
    public String getDescription() 
    { 
        return description; 
    }

    @Override 
    public Set<AttributeInfo> getOwnAttributes()
    { 
        return ownAttributes;
    }

    @Override 
    public Set<AttributeInfo> getAttributes()
    {
        return allAttributes;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByKey()
    {
        return allAttributesByKey;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByFieldName()
    {
        return allAttributesByFieldName;
    }
}
